## gr-osmosdr 0.2.3

=== CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of gr-osmosdr
#
# gr-osmosdr is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# gr-osmosdr is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with gr-osmosdr; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 3.8)
include(GNUInstallDirs)
project(gr-osmosdr CXX C)
enable_testing()

#policy setup
cmake_policy(SET CMP0011 NEW)

#select the release build type by default to get optimization flags
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")

########################################################################
# GNURadio setup
########################################################################
list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake/Modules)

# Find GNURadio (pmt and runtime are core, always included)
find_package(Gnuradio "3.8" REQUIRED COMPONENTS blocks fft filter)

# Set the version information here
set(VERSION_MAJOR 0)
set(VERSION_API   2)
set(VERSION_ABI   0)
set(VERSION_PATCH 0)
include(GrVersion) #setup version info

########################################################################
# Compiler specific setup
########################################################################

if((CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    AND NOT WIN32)
    #http://gcc.gnu.org/wiki/Visibility
    add_definitions(-fvisibility=hidden)
    add_definitions(-fvisibility-inlines-hidden)
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_STANDARD 11)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_CXX_STANDARD 11)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(CMAKE_CXX_STANDARD 11)
else()
    message(WARNING "C++ standard could not be set because compiler is not GNU, Clang or MSVC.")
endif()

# Misc options
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    add_definitions(-Wall)
    add_definitions(-Wextra)
    add_definitions(-Wno-unused-parameter)
    add_definitions(-Wsign-compare)
    #add_definitions(-Wconversion)
    #add_definitions(-pedantic)
    #add_definitions(-ansi)
endif()

# SIMD
if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64|AMD64|x86")
    set(USE_SIMD "SSE2" CACHE STRING "Use SIMD instructions")
else()
    set(USE_SIMD "no" CACHE STRING "Use SIMD instructions")
endif()
set(USE_SIMD_VALUES "no" "SSE2" "AVX")
set_property(CACHE USE_SIMD PROPERTY STRINGS ${USE_SIMD_VALUES})
list(FIND USE_SIMD_VALUES ${USE_SIMD} USE_SIMD_INDEX)
if(${USE_SIMD_INDEX} EQUAL -1)
    message(FATAL_ERROR "Option ${USE_SIMD} not supported, valid entries are ${USE_SIMD_VALUES}")
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    if(USE_SIMD MATCHES SSE2)
        add_definitions(-msse2)
        add_definitions(-DUSE_SSE2)
    endif()
    if(USE_SIMD MATCHES AVX)
        add_definitions(-march=native)
        add_definitions(-DUSE_AVX)
    endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    if(USE_SIMD MATCHES SSE2)
        add_definitions(/arch:SSE2)
        add_definitions(-DUSE_SSE2)
    endif()
    if(USE_SIMD MATCHES AVX)
        add_definitions(/arch:AVX)
        add_definitions(-DUSE_AVX)
    endif()
    # boost feels like using lib pragmas to link to libs,
    # but the boost libs might not even be in the (default) lib search path
    add_definitions(-DBOOST_ALL_NO_LIB)
    # macro turns std::min into errors...
    add_definitions(-DNOMINMAX)
endif()

########################################################################
# Find boost
########################################################################
find_package(Boost "1.65" REQUIRED chrono thread system)

if(NOT Boost_FOUND)
    message(FATAL_ERROR "Boost required to compile osmosdr")
endif()

########################################################################
# Find build dependencies and setup options
########################################################################

include(GrComponent)

set(ENABLE_NONFREE FALSE CACHE BOOL "Enable or disable nonfree components.")


    # GNURadio components & OOTs
    ##############################


    # Note this is not supposed to be lique that for GR components
    # but ATM GR's handling of components is broken
message(STATUS "Searching for GNURadio-Blocks...")
find_package(gnuradio-blocks PATHS ${Gnuradio_DIR})
message(STATUS " Found GNURadio-Blocks: ${gnuradio-blocks_FOUND}")

message(STATUS "Searching for IQ Balance...")
find_package(gnuradio-iqbalance PATHS ${Gnuradio_DIR})
message (STATUS " Found IQ Balance: ${gnuradio-iqbalance_FOUND}")

message(STATUS "Searching for UHD Drivers...")
find_package(UHD)
message (STATUS " Found UHD Driver: ${UHD_FOUND}")

message(STATUS "Searching for UHD Block...")
find_package(gnuradio-uhd PATHS ${Gnuradio_DIR})
message (STATUS " Found UHD Block: ${gnuradio-uhd_FOUND}")

message(STATUS "Searching for Volk...")
find_package(Volk REQUIRED)
message (STATUS " Found Volk: ${Volk_FOUND}")

    # Hardware drivers
    ####################

find_package(LibRTLSDR)
if(ENABLE_NONFREE)
    find_package(LibSDRplay)
endif(ENABLE_NONFREE)
find_package(LibHackRF)
find_package(LibAIRSPY)
find_package(LibAIRSPYHF)
find_package(LibbladeRF)
find_package(GnuradioFCDPP)
find_package(SoapySDR NO_MODULE)
find_package(LibFreeSRP)
find_package(LibXTRX)
find_package(Doxygen)

    # Python
    ##########

find_package(PythonLibs 3)
find_package(SWIG)

if(SWIG_FOUND)
    message(STATUS "Minimum SWIG version required is 1.3.31")
    set(SWIG_VERSION_CHECK FALSE)
    if("${SWIG_VERSION}" VERSION_GREATER "1.3.30")
        set(SWIG_VERSION_CHECK TRUE)
    endif()
endif(SWIG_FOUND)

GR_REGISTER_COMPONENT("Python support" ENABLE_PYTHON
    PYTHONLIBS_FOUND
    SWIG_FOUND
    SWIG_VERSION_CHECK
)

########################################################################
# Install directories
########################################################################
include(GrPlatform) #define LIB_SUFFIX

if(NOT CMAKE_MODULES_DIR)
    set(CMAKE_MODULES_DIR lib${LIB_SUFFIX}/cmake)
endif(NOT CMAKE_MODULES_DIR)

set(GR_INCLUDE_DIR      include)
set(GR_CMAKE_DIR        ${CMAKE_MODULES_DIR}/osmosdr)
set(GR_PKG_DATA_DIR     ${GR_DATA_DIR}/${CMAKE_PROJECT_NAME})
set(GR_PKG_DOC_DIR      ${GR_DOC_DIR}/${CMAKE_PROJECT_NAME})
set(GR_PKG_CONF_DIR     ${GR_CONF_DIR}/${CMAKE_PROJECT_NAME}/conf.d)
set(GR_PKG_LIBEXEC_DIR  ${GR_LIBEXEC_DIR}/${CMAKE_PROJECT_NAME})

########################################################################
# On Apple only, set install name and use rpath correctly, if not already set
########################################################################
if(APPLE)
    if(NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
            PATH "Library Install Name Destination Directory" FORCE)
    endif(NOT CMAKE_INSTALL_NAME_DIR)
    if(NOT CMAKE_INSTALL_RPATH)
        set(CMAKE_INSTALL_RPATH
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
            PATH "Library Install RPath" FORCE)
    endif(NOT CMAKE_INSTALL_RPATH)
    if(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
        set(CMAKE_BUILD_WITH_INSTALL_RPATH ON CACHE
            BOOL "Do Build Using Library Install RPath" FORCE)
    endif(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
endif(APPLE)

########################################################################
# Setup doxygen option
########################################################################
find_package(Doxygen)

if(DOXYGEN_FOUND)
    option(ENABLE_DOXYGEN "Build docs using Doxygen" ON)
else(DOXYGEN_FOUND)
    option(ENABLE_DOXYGEN "Build docs using Doxygen" OFF)
endif(DOXYGEN_FOUND)

########################################################################
# Create uninstall target
########################################################################
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
    )

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(include/osmosdr)
add_subdirectory(lib)
if(ENABLE_PYTHON)
    add_subdirectory(swig)
    add_subdirectory(python)
    add_subdirectory(grc)
    add_subdirectory(apps)
endif(ENABLE_PYTHON)
add_subdirectory(docs)

########################################################################
# Print Summary
########################################################################
GR_PRINT_COMPONENT_SUMMARY()
if(ENABLE_NONFREE)
    MESSAGE(STATUS
            "NONFREE components have been enabled. The resulting
   binaries cannot be distributed under GPL terms.
  ")
endif(ENABLE_NONFREE)

MESSAGE(STATUS "Building for version: ${VERSION} / ${LIBVER}")
MESSAGE(STATUS "Using install prefix: ${CMAKE_INSTALL_PREFIX}")

=== lib/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of gr-osmosdr
#
# gr-osmosdr is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# gr-osmosdr is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with gr-osmosdr; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Setup library
########################################################################
include(GrPlatform) #define LIB_SUFFIX

########################################################################
# Setup target
########################################################################

list(APPEND gr_osmosdr_srcs
    source_impl.cc
    sink_impl.cc
    ranges.cc
    device.cc
    time_spec.cc
)

#-pthread Adds support for multithreading with the pthreads library.
#This option sets flags for both the preprocessor and linker. (man gcc)
if(CMAKE_COMPILER_IS_GNUCXX)
    list(APPEND Boost_LIBRARIES -pthread)
endif()

#dirty macro to allow appending from subdirs
#this appends all unnamed implicit macro args!
MACRO (APPEND_LIB_LIST)
      SET (gr_osmosdr_libs "${gr_osmosdr_libs};${ARGN}" CACHE INTERNAL "lib list")
ENDMACRO (APPEND_INTERNAL_LIST)

set(gr_osmosdr_libs "" CACHE INTERNAL "lib that accumulates link targets")

add_library(gnuradio-osmosdr SHARED)
APPEND_LIB_LIST(${Boost_LIBRARIES} gnuradio::gnuradio-runtime)
target_include_directories(gnuradio-osmosdr
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
    PUBLIC ${Boost_INCLUDE_DIRS}
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
    PUBLIC $<INSTALL_INTERFACE:include>
  )
set_target_properties(gnuradio-osmosdr PROPERTIES DEFINE_SYMBOL "gnuradio_osmosdr_EXPORTS")

if(APPLE)
    set_target_properties(gnuradio-osmosdr PROPERTIES
        INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
    )
endif(APPLE)

########################################################################
# Setup defines for high resolution timing
########################################################################
message(STATUS "")
message(STATUS "Configuring high resolution timing...")
include(CheckCXXSourceCompiles)

set(CMAKE_REQUIRED_LIBRARIES -lrt)
CHECK_CXX_SOURCE_COMPILES("
    #include <ctime>
    int main(){
        timespec ts;
        return clock_gettime(CLOCK_MONOTONIC, &ts);
    }
    " HAVE_CLOCK_GETTIME
)
unset(CMAKE_REQUIRED_LIBRARIES)

include(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("
    #include <mach/mach_time.h>
    int main(){
        mach_timebase_info_data_t info;
        mach_timebase_info(&info);
        mach_absolute_time();
        return 0;
    }
    " HAVE_MACH_ABSOLUTE_TIME
)

CHECK_CXX_SOURCE_COMPILES("
    #include <Windows.h>
    int main(){
        LARGE_INTEGER value;
        QueryPerformanceCounter(&value);
        QueryPerformanceFrequency(&value);
        return 0;
    }
    " HAVE_QUERY_PERFORMANCE_COUNTER
)

if(HAVE_CLOCK_GETTIME)
    message(STATUS "  High resolution timing supported through clock_gettime.")
    set(TIME_SPEC_DEFS HAVE_CLOCK_GETTIME)
    APPEND_LIB_LIST( "-lrt")
elseif(HAVE_MACH_ABSOLUTE_TIME)
    message(STATUS "  High resolution timing supported through mach_absolute_time.")
    set(TIME_SPEC_DEFS HAVE_MACH_ABSOLUTE_TIME)
elseif(HAVE_QUERY_PERFORMANCE_COUNTER)
    message(STATUS "  High resolution timing supported through QueryPerformanceCounter.")
    set(TIME_SPEC_DEFS HAVE_QUERY_PERFORMANCE_COUNTER)
else()
    message(STATUS "  High resolution timing supported through microsec_clock.")
    set(TIME_SPEC_DEFS HAVE_MICROSEC_CLOCK)
endif()

set_source_files_properties(
    time_spec.cc
    PROPERTIES COMPILE_DEFINITIONS "${TIME_SPEC_DEFS}"
)

########################################################################
# Setup IQBalance component
########################################################################
GR_REGISTER_COMPONENT("Osmocom IQ Imbalance Correction" ENABLE_IQBALANCE gnuradio-iqbalance_FOUND)
if(ENABLE_IQBALANCE)
    add_definitions(-DHAVE_IQBALANCE=1)
    target_include_directories(gnuradio-osmosdr PRIVATE ${gnuradio-iqbalance_INCLUDE_DIRS})
    APPEND_LIB_LIST( gnuradio::gnuradio-iqbalance)
endif(ENABLE_IQBALANCE)

########################################################################
# Setup FCD component
########################################################################
GR_REGISTER_COMPONENT("FUNcube Dongle" ENABLE_FCD GNURADIO_FCDPP_FOUND)
if(ENABLE_FCD)
    add_subdirectory(fcd)
endif(ENABLE_FCD)

########################################################################
# Setup File component
########################################################################
GR_REGISTER_COMPONENT("IQ File Source & Sink" ENABLE_FILE gnuradio-blocks_FOUND)
if(ENABLE_FILE)
    add_subdirectory(file)
endif(ENABLE_FILE)

########################################################################
# Setup RTL component
########################################################################
GR_REGISTER_COMPONENT("Osmocom RTLSDR" ENABLE_RTL LIBRTLSDR_FOUND)
if(ENABLE_RTL)
    add_subdirectory(rtl)
endif(ENABLE_RTL)

########################################################################
# Setup RTL_TCP component
########################################################################
GR_REGISTER_COMPONENT("RTLSDR TCP Client" ENABLE_RTL_TCP gnuradio-blocks_FOUND)
if(ENABLE_RTL_TCP)
    add_subdirectory(rtl_tcp)
endif(ENABLE_RTL_TCP)

########################################################################
# Setup UHD component
########################################################################
GR_REGISTER_COMPONENT("Ettus USRP Devices" ENABLE_UHD UHD_FOUND gnuradio-uhd_FOUND)
if(ENABLE_UHD)
    add_subdirectory(uhd)
endif(ENABLE_UHD)

########################################################################
# Setup SDRplay component
########################################################################
if(ENABLE_NONFREE)
GR_REGISTER_COMPONENT("SDRplay RSP (NONFREE)" ENABLE_SDRPLAY LIBSDRPLAY_FOUND)
if(ENABLE_SDRPLAY)
    add_subdirectory(sdrplay)
endif(ENABLE_SDRPLAY)
endif(ENABLE_NONFREE)

########################################################################
# Setup HackRF component
########################################################################
GR_REGISTER_COMPONENT("HackRF & rad1o Badge" ENABLE_HACKRF LIBHACKRF_FOUND)
if(ENABLE_HACKRF)
    add_subdirectory(hackrf)
endif(ENABLE_HACKRF)

########################################################################
# Setup bladeRF component
########################################################################
GR_REGISTER_COMPONENT("nuand bladeRF" ENABLE_BLADERF LIBBLADERF_FOUND)
if(ENABLE_BLADERF)
    add_subdirectory(bladerf)
endif(ENABLE_BLADERF)

########################################################################
# Setup RFSPACE component
########################################################################
GR_REGISTER_COMPONENT("RFSPACE Receivers" ENABLE_RFSPACE)
if(ENABLE_RFSPACE)
    add_subdirectory(rfspace)
endif(ENABLE_RFSPACE)

########################################################################
# Setup AIRSPY component
########################################################################
GR_REGISTER_COMPONENT("AIRSPY Receiver" ENABLE_AIRSPY LIBAIRSPY_FOUND)
if(ENABLE_AIRSPY)
    add_subdirectory(airspy)
endif(ENABLE_AIRSPY)

########################################################################
# Setup AIRSPYHF component
########################################################################
GR_REGISTER_COMPONENT("AIRSPY HF+ Receiver" ENABLE_AIRSPYHF LIBAIRSPYHF_FOUND)
if(ENABLE_AIRSPYHF)
    add_subdirectory(airspyhf)
endif(ENABLE_AIRSPYHF)

########################################################################
# Setup SoapySDR component
########################################################################
GR_REGISTER_COMPONENT("SoapySDR support" ENABLE_SOAPY SoapySDR_FOUND)
if(ENABLE_SOAPY)
    add_subdirectory(soapy)
endif(ENABLE_SOAPY)

########################################################################
# Setup Red Pitaya component
########################################################################
GR_REGISTER_COMPONENT("Red Pitaya SDR" ENABLE_REDPITAYA)
if(ENABLE_REDPITAYA)
    add_subdirectory(redpitaya)
endif(ENABLE_REDPITAYA)

########################################################################
# Setup FreeSRP component
########################################################################
GR_REGISTER_COMPONENT("FreeSRP support" ENABLE_FREESRP LIBFREESRP_FOUND)
if(ENABLE_FREESRP)
    add_subdirectory(freesrp)
endif(ENABLE_FREESRP)

########################################################################
# Setup XTRX component
########################################################################
GR_REGISTER_COMPONENT("XTRX SDR" ENABLE_XTRX LIBXTRX_FOUND)
if(ENABLE_XTRX)
    add_subdirectory(xtrx)
endif(ENABLE_XTRX)

########################################################################
# Setup configuration file
########################################################################
add_definitions(-DHAVE_CONFIG_H=1)
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
@ONLY)

########################################################################
# Finalize target
########################################################################
set_target_properties(gnuradio-osmosdr PROPERTIES SOURCES "${gr_osmosdr_srcs}")
target_link_libraries(gnuradio-osmosdr ${gr_osmosdr_libs})

########################################################################
# Install built library files
########################################################################
include(GrMiscUtils)
GR_LIBRARY_FOO(gnuradio-osmosdr)

=== lib/hackrf/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of gr-osmosdr
#
# gr-osmosdr is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# gr-osmosdr is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with gr-osmosdr; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# This file included, use CMake directory variables
########################################################################

target_include_directories(gnuradio-osmosdr PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${LIBHACKRF_INCLUDE_DIRS}
)

APPEND_LIB_LIST(
    ${LIBHACKRF_LIBRARIES}
)

list(APPEND gr_osmosdr_srcs
    ${CMAKE_CURRENT_SOURCE_DIR}/hackrf_common.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/hackrf_source_c.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/hackrf_sink_c.cc
)
set(gr_osmosdr_srcs ${gr_osmosdr_srcs} PARENT_SCOPE)

=== lib/sdrplay/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of gr-osmosdr
#
# gr-osmosdr is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# gr-osmosdr is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with gr-osmosdr; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# This file included, use CMake directory variables
########################################################################

target_include_directories(gnuradio-osmosdr PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${LIBSDRPLAY_INCLUDE_DIRS}
)

APPEND_LIB_LIST(
    ${LIBSDRPLAY_LIBRARIES}
)

list(APPEND gr_osmosdr_srcs
    ${CMAKE_CURRENT_SOURCE_DIR}/sdrplay_source_c.cc
)
set(gr_osmosdr_srcs ${gr_osmosdr_srcs} PARENT_SCOPE)

=== lib/xtrx/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# This file included, use CMake directory variables
########################################################################

target_include_directories(gnuradio-osmosdr PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${LIBXTRX_INCLUDE_DIRS}
)

list(APPEND gr_osmosdr_srcs
    ${CMAKE_CURRENT_SOURCE_DIR}/xtrx_obj.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/xtrx_source_c.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/xtrx_sink_c.cc
)

set(gr_osmosdr_srcs ${gr_osmosdr_srcs} PARENT_SCOPE)

=== debian/changelog ===
gr-osmosdr (0.2.3-5build2) jammy; urgency=medium

  * No-change rebuild against gnuradio 3.10.1

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 08 Feb 2022 19:22:23 +0000

gr-osmosdr (0.2.3-5build1) jammy; urgency=medium

  * No-change rebuild against gnuradio 3.10.0

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 19 Jan 2022 15:11:29 +0000

gr-osmosdr (0.2.3-5) unstable; urgency=medium

  * fix libgnuradio-funcube dependency

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 01 Jan 2022 23:30:14 -0500

gr-osmosdr (0.2.3-4) unstable; urgency=medium

  * restore funcube support with new gr-funcube dependency
  * remove swig dependency
  * remove buggy xtrx dependency

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 29 Dec 2021 16:48:45 -0500

gr-osmosdr (0.2.3-3) unstable; urgency=medium

  * upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 09 Dec 2021 23:20:10 -0500

gr-osmosdr (0.2.3-2) experimental; urgency=medium

  * still waiting for gr-funcube

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 15 Nov 2021 22:49:50 -0500

gr-osmosdr (0.2.3-1) experimental; urgency=medium

  * New upstream release
  * still waiting for gr-iqbal and gr-funcube for gnuradio 3.9

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 10 Nov 2021 00:10:42 -0500

=== debian/control ===
Source: gr-osmosdr
Section: libdevel
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
	       dh-python,
               doxygen,
               gnuradio-dev (>=3.9),
	       gr-iqbal (>=0.38.2),
	       gr-funcube,
               libairspy-dev [!hurd-i386],
               libairspyhf-dev [!hurd-i386],
	       libasound2-dev,
               libbladerf-dev (>=0.2019.07) [!hurd-i386],
               libboost-dev,
	       libboost-chrono-dev,
               libboost-system-dev,
               libboost-thread-dev,
	       libfreesrp-dev [!hurd-i386],
	       libgmp-dev,
               libhackrf-dev [linux-any],
	       libhidapi-dev,
	       libjack-jackd2-dev,
               liblog4cpp5-dev,
	       libpulse-dev,
               librtlsdr-dev [!hurd-i386],
	       libsndfile1-dev,
	       libsoapysdr-dev,
               libuhd-dev (>=4.1),
               pkg-config,
	       portaudio19-dev,
               python3-dev,
	       python3-numpy,
	       python3-six,
	       python3-soapysdr
Standards-Version: 4.6.0
Homepage: http://sdr.osmocom.org/trac/wiki/GrOsmoSDR
Vcs-Browser: https://salsa.debian.org/bottoms/pkg-gr-osmosdr
Vcs-Git: https://salsa.debian.org/bottoms/pkg-gr-osmosdr.git

Package: gr-osmosdr
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: python3, ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Recommends: gnuradio, gr-fosphor
Description: Gnuradio blocks from the OsmoSDR project
 The Osmocom project is a family of projects regarding Open source
 mobile communications.
 .
 While primarily being developed for the OsmoSDR hardware, this block
 as well supports:
  - FUNcube Dongle through gr-fcdproplus
  - FUNcube Dongle Pro+ through gr-fcdproplus
  - RTL2832U based DVB-T dongles through librtlsdr
  - RTL-TCP spectrum server (see librtlsdr project)
  - gnuradio .cfile input through libgnuradio-blocks
  - RFSPACE SDR-IQ, SDR-IP, NetSDR (incl. X2 option)
  - Great Scott Gadgets HackRF through libhackrf
  - Nuand LLC bladeRF through libbladeRF library
  - Ettus USRP Devices through Ettus UHD library
  - Fairwaves UmTRX through Fairwaves' fork of UHD
  - AIRSPY Receiver
  - AIRSPY HF+ Receiver
  - SoapySDR support
  - Red Pitaya SDR transceiver (http://bazaar.redpitaya.com)
  - FreeSRP through libfreesrp
 .
 Example applications include osmocom_fft, osmocom_siggen,
 and osmocom_spectrum_sense.
 .
 By using the OsmoSDR block you can take advantage of a common
 software API in your application(s) independent of the underlying
 radio hardware. This package provides C++ header files,
 documentation, and Python3 wrappers to the library.

Package: libgnuradio-osmosdr0.2.0
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Gnuradio blocks from the OsmoSDR project - library
 The Osmocom project is a family of projects regarding Open source
 mobile communications.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH
DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))
VER=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: ([^-]+).*,\1,p')
GITREV=$(shell echo $(VER) | sed -rne 's,[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+\.([0-f]+),\1,p')

%:
	dh $@ --with python3 --with numpy3

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"

override_dh_auto_install:
	rm -f debian/gr-osmosdr/usr/lib/python3/dist-packages/osmosdr/*pyc
	rm -f debian/gr-osmosdr/usr/lib/python3/dist-packages/osmosdr/*pyo
	dh_auto_install

version-to-get:
	echo $(VER) is $(GITREV)

get-orig-source: version-to-get
	git clone git://git.osmocom.org/gr-osmosdr
	cd gr-osmosdr && git archive --format=tar --prefix=gr-osmosdr-$(VER)/  $(GITREV) | xz > ../gr-osmosdr_$(VER).orig.tar.xz
	rm -rf gr-osmosdr

=== debian/watch ===
version=4
 opts="mode=git, gitmode=full, pgpmode=none" \
 https://git.osmocom.org/gr-osmosdr \
 refs/tags/v([\d\.]+) debian uupdate

## gr-osmosdr 0.2.4

=== grc/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of gr-osmosdr
#
# gr-osmosdr is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# gr-osmosdr is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with gr-osmosdr; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Rules for generating the source and sink yml wrappers
########################################################################
include(GrPython)

macro(GEN_BLOCK_YAML _generator _yaml_block)
    set(generator ${CMAKE_CURRENT_SOURCE_DIR}/${_generator})
    set(yaml_block ${CMAKE_CURRENT_BINARY_DIR}/${_yaml_block})
    list(APPEND yaml_blocks ${yaml_block})
    add_custom_command(
        DEPENDS ${generator} OUTPUT ${yaml_block}
        COMMAND ${PYTHON_EXECUTABLE} ${generator} ${yaml_block}
    )
endmacro(GEN_BLOCK_YAML)

GEN_BLOCK_YAML(gen_osmosdr_blocks.py    rtlsdr_source.block.yml)
GEN_BLOCK_YAML(gen_osmosdr_blocks.py    osmosdr_source.block.yml)
GEN_BLOCK_YAML(gen_osmosdr_blocks.py    osmosdr_sink.block.yml)

add_custom_target(osmosdr_grc_yaml_blocks ALL DEPENDS ${yaml_blocks})

install(FILES
    ${yaml_blocks}
    DESTINATION share/gnuradio/grc/blocks
)

=== include/osmosdr/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of gr-osmosdr
#
# gr-osmosdr is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# gr-osmosdr is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with gr-osmosdr; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Install public header files
########################################################################
install(FILES
    api.h
    pimpl.h
    ranges.h
    time_spec.h
    device.h
    source.h
    sink.h
    DESTINATION include/osmosdr
)

=== lib/freesrp/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of gr-osmosdr
#
# gr-osmosdr is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# gr-osmosdr is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with gr-osmosdr; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# This file included, use CMake directory variables
########################################################################

target_include_directories(gnuradio-osmosdr PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${LIBFREESRP_INCLUDE_DIRS}
)

APPEND_LIB_LIST(
    ${LIBFREESRP_LIBRARIES}
)

list(APPEND gr_osmosdr_srcs
    ${CMAKE_CURRENT_SOURCE_DIR}/freesrp_common.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/freesrp_source_c.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/freesrp_sink_c.cc
)
set(gr_osmosdr_srcs ${gr_osmosdr_srcs} PARENT_SCOPE)

=== lib/redpitaya/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of gr-osmosdr
#
# gr-osmosdr is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# gr-osmosdr is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with gr-osmosdr; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# This file included, use CMake directory variables
########################################################################

target_include_directories(gnuradio-osmosdr PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

APPEND_LIB_LIST(
    ${Gnuradio-blocks_LIBRARIES}
)

list(APPEND gr_osmosdr_srcs
    ${CMAKE_CURRENT_SOURCE_DIR}/redpitaya_source_c.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/redpitaya_sink_c.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/redpitaya_common.cc
)
set(gr_osmosdr_srcs ${gr_osmosdr_srcs} PARENT_SCOPE)

=== lib/rtl_tcp/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of gr-osmosdr
#
# gr-osmosdr is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# gr-osmosdr is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with gr-osmosdr; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# This file included, use CMake directory variables
########################################################################

target_include_directories(gnuradio-osmosdr PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

APPEND_LIB_LIST(
    ${Gnuradio-blocks_LIBRARIES}
)

list(APPEND gr_osmosdr_srcs
    ${CMAKE_CURRENT_SOURCE_DIR}/rtl_tcp_source_c.cc
)
set(gr_osmosdr_srcs ${gr_osmosdr_srcs} PARENT_SCOPE)

=== debian/changelog ===
gr-osmosdr (0.2.4-3) unstable; urgency=medium

  * improve clean target (Closes: #1044374)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 26 Nov 2023 19:25:43 -0500

gr-osmosdr (0.2.4-2) unstable; urgency=medium

  * Update to v0.2.4-9-g48422c8
    fix gain mode caching
    rtlsdr detect RTL-SDR Blog V4 set lower tuning limit

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 26 Nov 2023 11:20:58 -0500

gr-osmosdr (0.2.4-1) unstable; urgency=medium

  * New upstream release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 20 Jan 2023 22:12:25 -0500

gr-osmosdr (0.2.3-7) unstable; urgency=medium

  * pull new upstream commits and build using gr-funcube and gnuradio 3.10

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 23 Aug 2022 19:32:08 -0400

gr-osmosdr (0.2.3-6) unstable; urgency=medium

  * clarify FreeSRP namespace scope (Closes: #1008865)
  * apps/osmocom_fft qtgui: Replace pyqwidget() with qwidget()
    (Closes: #1004526)
  * enable XTRX SDR support

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 03 Apr 2022 10:52:14 -0400

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
 	       dh-python,
                doxygen,
                gnuradio-dev (>=3.9),
+	       gr-funcube,
 	       gr-iqbal (>=0.38.2),
-	       gr-funcube,
                libairspy-dev [!hurd-i386],
                libairspyhf-dev [!hurd-i386],
 	       libasound2-dev,
@@ -28,16 +28,18 @@
 	       libsndfile1-dev,
 	       libsoapysdr-dev,
                libuhd-dev (>=4.1),
+	       libxtrx-dev,
                pkg-config,
 	       portaudio19-dev,
                python3-dev,
 	       python3-numpy,
 	       python3-six,
 	       python3-soapysdr
-Standards-Version: 4.6.0
-Homepage: http://sdr.osmocom.org/trac/wiki/GrOsmoSDR
+Standards-Version: 4.6.2
+Homepage: https://osmocom.org/projects/osmosdr/wiki
 Vcs-Browser: https://salsa.debian.org/bottoms/pkg-gr-osmosdr
 Vcs-Git: https://salsa.debian.org/bottoms/pkg-gr-osmosdr.git
+Testsuite: autopkgtest-pkg-pybuild
 
 Package: gr-osmosdr
 Architecture: any
@@ -50,8 +52,8 @@
  .
  While primarily being developed for the OsmoSDR hardware, this block
  as well supports:
-  - FUNcube Dongle through gr-fcdproplus
-  - FUNcube Dongle Pro+ through gr-fcdproplus
+  - FUNcube Dongle through gr-funcube
+  - FUNcube Dongle Pro+ through gr-funcube
   - RTL2832U based DVB-T dongles through librtlsdr
   - RTL-TCP spectrum server (see librtlsdr project)
   - gnuradio .cfile input through libgnuradio-blocks
@@ -82,6 +84,7 @@
 Multi-Arch: same
 Description: Gnuradio blocks from the OsmoSDR project - library
  The Osmocom project is a family of projects regarding Open source
- mobile communications.
+ mobile communications. This library provides hardware support for
+ a variety of radio hardware in the form of gnuradio blocks.
  .
  This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with python3 --with numpy3

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"

override_dh_auto_install:
	rm -f debian/gr-osmosdr/usr/lib/python3/dist-packages/osmosdr/*pyc
	rm -f debian/gr-osmosdr/usr/lib/python3/dist-packages/osmosdr/*pyo
	dh_auto_install $@

override_dh_auto_clean:
	rm -rf docs/doxygen/doxyxml/__pycache__
	rm -rf docs/doxygen/doxyxml/generated/__pycache__
	dh_auto_clean $@
